/*************************************************************************/
/*                                                                       */
/*                  Language Technologies Institute                      */
/*                     Carnegie Mellon University                        */
/*                        Copyright (c) 2001                             */
/*                        All Rights Reserved.                           */
/*                                                                       */
/*  Permission is hereby granted, free of charge, to use and distribute  */
/*  this software and its documentation without restriction, including   */
/*  without limitation the rights to use, copy, modify, merge, publish,  */
/*  distribute, sublicense, and/or sell copies of this work, and to      */
/*  permit persons to whom this work is furnished to do so, subject to   */
/*  the following conditions:                                            */
/*   1. The code must retain the above copyright notice, this list of    */
/*      conditions and the following disclaimer.                         */
/*   2. Any modifications must be clearly marked as such.                */
/*   3. Original authors' names are not deleted.                         */
/*   4. The authors' names are not used to endorse or promote products   */
/*      derived from this software without specific prior written        */
/*      permission.                                                      */
/*                                                                       */
/*  CARNEGIE MELLON UNIVERSITY AND THE CONTRIBUTORS TO THIS WORK         */
/*  DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING      */
/*  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT   */
/*  SHALL CARNEGIE MELLON UNIVERSITY NOR THE CONTRIBUTORS BE LIABLE      */
/*  FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES    */
/*  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN   */
/*  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,          */
/*  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF       */
/*  THIS SOFTWARE.                                                       */
/*                                                                       */
/*************************************************************************/
/*             Author:  Alan W Black (awb@cs.cmu.edu)                    */
/*               Date:  January 2001                                     */
/*************************************************************************/
/*                                                                       */
/*  au_ahi.c: audio support for AHI (AmigaOS)                            */
/*  by Fredrik Wikstrom (fredrik@a500.org) 27.12.04                      */
/*  au_none.c used as basis                                              */
/*                                                                       */
/*************************************************************************/

#ifdef __amigaos4__
#define __USE_INLINE__ 1
#endif

#include <stdio.h>
#include <stdlib.h>
#include "cst_string.h"
#include "cst_wave.h"
#include "cst_audio.h"

#include <proto/exec.h>
#include <proto/dos.h>

typedef struct {
	BPTR ahi_out;
} au_ahi_pdata;

int audio_close_ahi(cst_audiodev *ad);

cst_audiodev * audio_open_ahi(int sps, int channels, int fmt)
{
	cst_audiodev *ad;
	au_ahi_pdata *pd;
	char out_file[100];
	int bits = 0;

	ad = cst_alloc(cst_audiodev,1);
	ad->sps = ad->real_sps = sps;
	ad->channels = ad->real_channels = channels;
	ad->fmt = ad->real_fmt = fmt;
    
	switch (fmt) {
		case CST_AUDIO_LINEAR8:
			bits = 8;
			break;
		case CST_AUDIO_LINEAR16:
			bits = 16;
			break;
	}
    
	snprintf(out_file,100,"AUDIO:B/%d/C/%d/F/%d",bits,channels,sps);
    
	ad->platform_data = cst_alloc(au_ahi_pdata,1);
	pd = (au_ahi_pdata *)ad->platform_data;
	pd->ahi_out = Open(out_file,MODE_NEWFILE);
    
	return ad;
}

int audio_close_ahi(cst_audiodev *ad)
{
	au_ahi_pdata *pd;
	if (ad) {
		pd = (au_ahi_pdata *)ad->platform_data;
		if (pd) {
			Close(pd->ahi_out);
			cst_free(pd);
		}
		cst_free(ad);
	}
	return 0;
}

int audio_write_ahi(cst_audiodev *ad, void *samples, int num_bytes)
{
	au_ahi_pdata *pd;
	pd = (au_ahi_pdata *)ad->platform_data;
	Write(pd->ahi_out,samples,num_bytes);
	return num_bytes;
}

int audio_drain_ahi(cst_audiodev *ad)
{
	au_ahi_pdata *pd;
	pd = (au_ahi_pdata *)ad->platform_data;
	return 0;
}

int audio_flush_ahi(cst_audiodev *ad)
{
	au_ahi_pdata *pd;
	pd = (au_ahi_pdata *)ad->platform_data;
	//Flush(pd->ahi_out);
	return 0;
}
